//Vector3 class implementation

#include "vector3.h"

Vector3 Vector3::Cross(Vector3 vVector1, Vector3 vVector2)
{
	Vector3 vNormal;	

	//Calculate the cross product
	vNormal.x = ((vVector1.y * vVector2.z) - (vVector1.z * vVector2.y));
	vNormal.y = ((vVector1.z * vVector2.x) - (vVector1.x * vVector2.z));
	vNormal.z = ((vVector1.x * vVector2.y) - (vVector1.y * vVector2.x));

	return vNormal;		
}

GLfloat Vector3::Magnitude(Vector3 vNormal)
{
	//Calculate the magnitude of the vector
	return (GLfloat)sqrt( (vNormal.x * vNormal.x) + 
						(vNormal.y * vNormal.y) + 
						(vNormal.z * vNormal.z) );
}

Vector3 Vector3::Normalize(Vector3 vVector)
{
	GLfloat magnitude = Magnitude(vVector);				

	//Divide the original vector by the magnitude vector to find the normal vector  
	vVector = vVector / magnitude;		

	return vVector;		
}